import java.awt.Color;


/**
 * A class representing a bead in a necklace
 * 
 * @author YOUR NAMES HERE
 */
public class Bead
{
	private Color color; //the color of the bead
	private int size; //the size (diameter) of the bead
	private Bead hook; //a hook onto which the next bead can be linked

	/**
	 * Constructs a new bead with a random color and size
	 */
	public Bead()
	{
		color = Palette.getRandomColor();
		size = (int)(Math.random()*20)+10; //random size between 20 and 30
		hook = null;
	}

	/**
	 * Creates a new bead with the given color and size
	 * @param color The bead's color
	 * @param size The bead's size
	 */
	public Bead(Color color, int size)
	{
		this.color = color;
		this.size = size;
		hook = null;
	}
	
	/**
	 * Returns the bead's color
	 * @return the bead's color
	 */
	public Color getColor()
	{
		return color;
	}
	
	/**
	 * Returns the bead's size
	 * @return the bead's size
	 */
	public int getSize()
	{
		return size;
	}

	/**
	 * Returns the Bead that is hooked onto this one, or null if no bead is attached
	 * @return The bead that is hooked onto this
	 */
	public Bead getHooked()
	{
		return hook;
	}
	
	/**
	 * Attaches a bead to this bead's hook. Note that this will replace any previously attached Beads.
	 * @param toAttach The bead to attach.
	 */
	public void setHooked(Bead toAttach)
	{
		hook = toAttach;
	}
	
	public String toString()
	{
		return "Bead[color "+Palette.getColorRank(this.color)+", size: "+size+"]";
	}
	
}
